// ==============================================================================================-
// EditChild.h : header file for EditChild class
// ==============================================================================================-

#if !defined(_EDITCHILD_H_)
#define _EDITCHILD_H_

#define _MAX_OPEN_CHILDS 5
#define _EDIT_COLUMN_SIZE_LEFT 20


// ==============================================================================================-
// definitions
//

enum
{
  EC_SAVE_DEFAULT,
  EC_SAVE_AS,
  EC_SAVE_ALL
};

enum
{
  EC_SHOW_ACTIVATE,
  EC_SHOW_RESTORE,
  EC_SHOW_MINIMIZE,
  EC_SHOW_MAXIMIZE
};

#define EC_CLOSE_ALL (HWND)-1


// ==============================================================================================-
// global functions
//

extern void initEditChild();
extern int  createEditChild(LPTSTR lpszName = NULL);
extern BOOL showEditChild(UINT uMsg, HWND hwndChild = NULL);
extern BOOL saveEditChild(WORD fwFlags, HWND hwndChild = NULL);
extern BOOL closeEditChild(HWND hwndChild = NULL);
extern void deinitEditChild();

extern LRESULT CALLBACK EditProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);


// ==============================================================================================-
// class EditChild : implemented in MainApp.cpp
//

class EditChild
{
// -----------------------------------------------------------------------------------------------
// methods

public:
  EditChild(LPTSTR lpszName, int index);
  ~EditChild();

// -----------------------------------------------------------------------------------------------
// data

public:
  BOOL fFailed;       //true if window could not be created

  HWND hwndEdit;
  HWND hwndEditBar;
  HWND hwndEditCntrl;

  BOOL fChanged;      //true if contents changed
  LPSTR lpszFileName;
};


extern EditChild *pEditChild[_MAX_OPEN_CHILDS];


#endif