// ==============================================================================================-
// OutputWnd.h : header file for OutputWnd class
// ==============================================================================================-

#if !defined(_OUTPUTWND_H_)
#define _OUTPUTWND_H_


// ==============================================================================================-
// definitions
//

#define OUTPUT_SPACE_L 0
#define OUTPUT_SPACE_R 0
#define OUTPUT_SPACE_T 5
#define OUTPUT_SPACE_B 0

#define OUTPUT_HEIGHT_MIN (5+5)


// ==============================================================================================-
// global functions
//

LRESULT CALLBACK OutputWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);


// ==============================================================================================-
// class Output : implemented in MainApp.cpp
//

class OutputWnd
{
// -----------------------------------------------------------------------------------------------
// methods

public:
  OutputWnd(HWND hwnd);
  ~OutputWnd();

  BOOL SetDragState(HWND hwnd, BOOL fState);
  BOOL OnMouseMove(HWND hwnd);
  BOOL OnSetCursor(HWND hwnd);
  BOOL OnSize(HWND hwnd, LPARAM lParam);

// -----------------------------------------------------------------------------------------------
// data

public:
  BOOL fFailed;
  HWND hwndParent;
  HWND hwndTree;        //handle of list-view

  BYTE bDragState;
  HCURSOR hCursor;

  LPSTR lpszFileName;   //name of workspace-file
};


#endif