// ==============================================================================================-
// Workspace.cpp : class for the wndow on the left
// ==============================================================================================-

#include "main.h"
#include "Workspace.h"


// ==============================================================================================-
// global data

// ==============================================================================================-
// global functions

LRESULT CALLBACK WorkspaceWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  Workspace *lpWs;
  switch(uMsg)
  {
  case WM_CREATE:
    lpWs = new Workspace(hwnd);
    if(lpWs->fFailed) return(-1);
    SetWindowLong(hwnd, 0, (LONG)lpWs);
    break;

  case WM_MOUSEMOVE:
    lpWs = (Workspace*)GetWindowLong(hwnd, 0);
    if(lpWs && lpWs->OnMouseMove(hwnd)) return(0);
    break;

  case WM_SETCURSOR:
    lpWs = (Workspace*)GetWindowLong(hwnd, 0);
    if(lpWs && lpWs->OnSetCursor(hwnd)) return(0);
    break;

  case WM_SIZE:
    lpWs = (Workspace*)GetWindowLong(hwnd, 0);
    if(lpWs && lpWs->OnSize(hwnd, lParam)) return(0);
    break;

  case WM_LBUTTONUP:
    lpWs = (Workspace*)GetWindowLong(hwnd, 0);
    if(lpWs && lpWs->SetDragState(hwnd, false)) return(0);
    break;
  case WM_LBUTTONDOWN:
    lpWs = (Workspace*)GetWindowLong(hwnd, 0);
    if(lpWs && lpWs->SetDragState(hwnd, true)) return(0);
    break;

  case WM_DESTROY:
    lpWs = (Workspace*)GetWindowLong(hwnd, 0);
    if(lpWs) delete lpWs;
    break;
  }

  return( DefWindowProc(hwnd, uMsg, wParam, lParam) );
}


// ==============================================================================================-
// Workspace: methods


// -----------------------------------------------------------------------------------------------
BOOL Workspace::loadWorkspaceFile(LPSTR lpszFile)
{
  /*freeWorkspaceFile();

  FILE *fh = fopen(lpszFile, "rb");
  if(!fh) return false;

  //...load...

  fclose(fh);
  lpszWsFile = (LPSTR)theApp.malloc(strlen(lpszFile)+1);
  if(!lpszWsFile) return false;
  strcpy(lpszWsFile, lpszFile);*/
  return true;
}

// -----------------------------------------------------------------------------------------------
BOOL Workspace::saveWorkspaceFile()
{
  /*FILE *fh = fopen(lpszWsFile, "wb");
  if(!fh) return false;

  //...write...

  fclose(fh);*/
  return false;
}

// -----------------------------------------------------------------------------------------------
void Workspace::freeWorkspace()
{
  //...free...
  
  TreeView_DeleteAllItems(hwndTree);
}


// -----------------------------------------------------------------------------------------------
// constructor
Workspace::Workspace(HWND hwnd)
{
  fFailed = false;
  hwndParent = hwnd;

  bDragState = 0;
  hCursor = LoadCursor(NULL, IDC_SIZEWE);

  fLoaded = false;
  lpszWsFile = NULL;
  WorkspaceData = NULL;

  hwndTree = CreateWindowEx(
		WS_EX_CLIENTEDGE, //|WS_EX_ACCEPTFILES,
		WC_TREEVIEW, NULL,
		WS_VISIBLE|WS_CHILD|
    TVS_SHOWSELALWAYS|TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS,
		0,0,0,0, hwnd, NULL, theApp.hInstance, NULL
	);
  if(!hwndTree)
  {
  //_failed:
    fFailed = true;
    theApp.doErrorDlg("create workspace window failed.");
    return;
  }


  TV_INSERTSTRUCT tvi;
  tvi.hParent = TVI_ROOT;
  tvi.hInsertAfter = TVI_LAST;
  tvi.item.mask = TVIF_TEXT;
  tvi.item.pszText = "no workspace loaded";
  TreeView_InsertItem(hwndTree, &tvi);

  //EnableWindow(hwndTree, false);
}

// -----------------------------------------------------------------------------------------------
// destructor
Workspace::~Workspace()
{
}


// -----------------------------------------------------------------------------------------------
// called on WM_LBUTTONXXX
BOOL Workspace::SetDragState(HWND hwnd, BOOL fState)
{
  if(fState)
  {
    if(bDragState!=1) return false;
    bDragState++;
    SetCapture(hwnd);
  }
  else
  {
    if(bDragState!=2) return false;
    bDragState = 0;
    ReleaseCapture();
  }

  return true;
}

// -----------------------------------------------------------------------------------------------
// mouse move
BOOL Workspace::OnMouseMove(HWND hwnd)
{
  if(bDragState!=2) return false;

  POINT pnt;
  if( !GetCursorPos(&pnt) ) return false;

  RECT rect;
  GetWindowRect(hwnd, &rect);
  theApp.settings.nWorkspaceWidth = pnt.x - rect.left;

  if(theApp.settings.nWorkspaceWidth < WORKSPACE_WIDTH_MIN)
    theApp.settings.nWorkspaceWidth = WORKSPACE_WIDTH_MIN;
  GetClientRect(theApp.hwndMain, &rect);
  if(theApp.settings.nWorkspaceWidth > rect.right-WORKSPACE_WIDTH_MIN)
    theApp.settings.nWorkspaceWidth = rect.right-WORKSPACE_WIDTH_MIN;

  theApp.onSize();
  UpdateWindow(theApp.hwndMain);
  return true;
}

// -----------------------------------------------------------------------------------------------
// cursor over window
BOOL Workspace::OnSetCursor(HWND hwnd)
{
  POINT pnt;
  if( !GetCursorPos(&pnt) ) return false;

  RECT rect;
  GetWindowRect(hwnd, &rect);
  if( pnt.x >= rect.right-WORKSPACE_SPACE_R && pnt.x <= rect.right )
  {
    SetCursor( hCursor );
    bDragState = 1;
    return true;
  }

  bDragState = 0;
  return false;
}

// -----------------------------------------------------------------------------------------------
// resize window
BOOL Workspace::OnSize(HWND hwnd, LPARAM lParam)
{
  SetWindowPos(hwndTree, HWND_TOP,
    WORKSPACE_SPACE_L, WORKSPACE_SPACE_T,
    LOWORD(lParam)-WORKSPACE_SPACE_L-WORKSPACE_SPACE_R,
    HIWORD(lParam)-WORKSPACE_SPACE_T-WORKSPACE_SPACE_B,
    SWP_NOACTIVATE|SWP_NOZORDER
  );
  return false;
}


// -----------------------------------------------------------------------------------------------