// ==============================================================================================-
// main.cpp : includes the WinMain and WindowProc functions
//
//  done:
//    - base
//    - resizing of workspace/output window
//
//  fixed errors:
//    - display error of the workspace/output wnd./statusbar/toolbar on sizing
//    - the open files are only viewed in the windows-menu (id 6), after u open some files and
//      then close one (but the first window is never checked)
//    - if u create a new child, this is not active (WM_MDIACTIVATE doesnt work?)
//
//  known errors:
//    - (win2k) could not create edit-child window
//  
//  not supported yet:
//    - workspace
//    - load/save configuration/settings
//    - load/save text files
//    - text operations and edit context menu
//    - execute compiler and filter output (with external dll support)
//    - text highlighting (with dll or script-support for different extension/file types)
//
// ==============================================================================================-

#include "main.h"


// ==============================================================================================-
// first and least: the only MainApp object

MainApp theApp("PSXdev IDE V0.01 (beta)");


// ==============================================================================================-
// the WinProc

LRESULT CALLBACK WndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  return( theApp.MessageHandler(hwnd, uMsg, wParam, lParam) );
}


// ==============================================================================================-
// the WinMain

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR lpCmdLine, int nCmdShow)
{
  InitCommonControls();
  LoadLibrary("RICHED32.DLL");

  //init data members of main app
  theApp.hInstance = hInstance;
  theApp.lpszCmdLine = GetCommandLine();
  theApp.nCmdShow = nCmdShow;

  if( !theApp.initInstance() )
  {
    theApp.doErrorDlg("init instance failed.");
    theApp.exitInstance();
    return(NULL);
  }

  return( theApp.run() );
}